---
title: PublicKeyCredentialCreationOptions.authenticatorSelection
slug: Web/API/PublicKeyCredentialCreationOptions/authenticatorSelection
tags:
  - API
  - Property
  - PublicKeyCredentialCreationOptions
  - Reference
  - Web Authentication API
  - WebAuthn
---
<div>{{APIRef("Web Authentication API")}}{{securecontext_header}}</div>

<p><strong><code>authenticatorSelection</code></strong>, an optional property of the {{domxref("PublicKeyCredentialCreationOptions")}} dictionary, is an object giving criteria to filter out the authenticators to be used for the creation operation.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>authenticatorSelection</em> = <em>publicKeyCredentialCreationOptions</em>.authenticatorSelection</pre>

<h3 id="Value">Value</h3>

<p>An object with the following properties:</p>

<dl>
 <dt><code>authenticatorAttachment</code>{{optional_inline}}</dt>
 <dd>A string which is either "<code>platform</code>" or "<code>cross-platform</code>". The former describes an authenticator which is bound to the client and which is generally not removable. The latter describes a device which may be used across different platform (such as a USB or NFC device).</dd>
 <dt><code>requireResidentKey</code>{{optional_inline}}</dt>
 <dd>A boolean which indicated that the credential private key must be stored in the authenticator, the client or in a client device. The default value is <code>false</code>.</dd>
 <dt><code>userVerification</code>{{optional_inline}}</dt>
 <dd>A string qualifying how the user verification should be part of the authentication process. The values may be:
 <ul>
  <li>"<code>required</code>": user verification is required, the operation will fail if the {{domxref("AuthenticatorAttestationResponse","response","",1)}} does not have the UV flag (as part of the <code>authenticatorData</code> property of {{domxref("AuthenticatorAttestationResponse.attestationObject")}})</li>
  <li>"<code>preferred</code>": user verification is prefered, the operation will not fail if the {{domxref("AuthenticatorAttestationResponse","response","",1)}} does not have the UV flag (as part of the <code>authenticatorData</code> property of {{domxref("AuthenticatorAttestationResponse.attestationObject")}})</li>
  <li>"<code>discouraged</code>": user verification should not be employed as to minimize the user interaction during the process.</li>
 </ul>
 The default value is "<code>preferred</code>".</dd>
</dl>

<p>The authenticator used for the creation of the public key credential must comply with the requirements.</p>

<div class="notecard note">
<p><strong>Note: </strong>See {{domxref("PublicKeyCredential.isUserVerifyingPlatformAuthenticatorAvailable()")}} which resolves to <code>true</code> when a user-verifiying platform authenticator is available.</p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var publicKey = {
  authenticatorSelection:{
    authenticatorAttachment: "cross-platform",
    requireResidentKey: true,
    userVerification: "required"
  },
  challenge: new Uint8Array(26) /* this actually is given from the server */,
  rp: {
    name: "Example CORP",
    id  : "login.example.com"
  },
  user: {
    id: new Uint8Array(26), /* To be changed for each user */
    name: "jdoe@example.com",
    displayName: "John Doe",
  },
  pubKeyCredParams: [ {
    type: "public-key",
    alg: -7 } ]
};

navigator.credentials.create({ publicKey })
  .then(function (newCredentialInfo) {
    // send attestation response and client extensions
    // to the server to proceed with the registration
    // of the credential
  }).catch(function (err) {
     console.error(err);
  });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn','#dom-publickeycredentialcreationoptions-authenticatorselection','authenticatorSelection')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredentialCreationOptions.authenticatorSelection")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("PublicKeyCredential.isUserVerifyingPlatformAuthenticatorAvailable()")}}</li>
 <li>{{domxref("AuthenticatorAssertionResponse.authenticatorData")}} whose structure contains the UV flag (please note that for the creation operation, {{domxref("AuthenticatorAttestationResponse.attestationObject")}} only contains a CBOR encoded version of this data and does not give an immediate access to the flag).</li>
</ul>
